<template>
  <form
    id="logoUploadForm"
    novalidate="novalidate"
  >
    <div class="form-group">
      <label for="logoUpload">Logo personnalisé</label>
      <el-upload
        id="logoUpload"
        ref="logoUpload"
        class="upload-logo"
        drag
        action="api/checklogo"
        :file-list="fileList"
        :data="uploadData"
        :limit="1"
        :on-error="handleLogoError"
        :on-success="handleLogoUploaded"
      >
        <i class="el-icon-upload" />
        <div class="el-upload__text">
          Déposer l'image ici ou <em>cliquez pour envoyer</em>
          <br>
          <br>
        </div>
        <div
          slot="tip"
          class="el-upload__tip"
        >
          Fichier PNG avec une taille inférieure à 3Mo<br>
        </div>
      </el-upload>
    </div>
  </form>
</template>

<script>
import {mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";

export default {
  name: "LogoUploadForm",
  components: {},
  props: {
    reset: {
      type: Number,
      default: 0
    },
  },
  data() {
    return {
      validator: null,
      logoUpload: null,
      fileList: [],
      uploadData: null,
      fileLength: 0,
      fileAndIndex: null
    }
  },
  computed: {
    ...mapGetters([
      'isLoading',
      'logoHasError'
    ])
  },
  watch: {
    reset: function (newVal) {
      if(newVal===1) {
        this.$refs.logoUpload.clearFiles()
        this.$emit('formReseted')
      }
    }
  },
  mounted() {
    this.validator = $('#logoUploadForm').submit(function(e) {
      e.preventDefault()
    })
  },
  methods: {
    handleLogoError() {
      VanillaToasts.create({
        title: 'Transmission de logo',
        text: 'Une erreur est survenue lors de la transmission du fichier. Merci de vérifier la taille < 3Mo et l\'extension PNG obligatoire.',
        type: 'error',
        timeout: 10000,
      });
    },
    handleLogoUploaded(res, file) {
      this.$emit('logoUploaded', {
        url: URL.createObjectURL(file.raw),
        file: file
      })
    }
  }
}
</script>

<style>
.el-upload .el-upload__input {
  display: none !important;
}
</style>